.386
.MODEL FLAT,STDCALL
option casemap:none

include	\GeneSys\include\windows.inc
include	\GeneSys\include\user32.inc
include	\GeneSys\include\kernel32.inc
include \GeneSys\include\shell32.inc
include \GeneSys\include\comctl32.inc
include \GeneSys\include\ole32.inc
include \GeneSys\include\urlmon.inc
include \GeneSys\include\GeneSys.inc

includelib \GeneSys\lib\user32.lib
includelib \GeneSys\lib\kernel32.lib
includelib \GeneSys\lib\shell32.lib
includelib \GeneSys\lib\comctl32.lib
includelib \GeneSys\lib\ole32.lib
includelib \GeneSys\lib\urlmon.lib
includelib \GeneSys\lib\GeneSys.lib

include \GeneSys\macros\macros.asm
	  
DialogProc				PROTO :HWND, :UINT, :WPARAM, :LPARAM
AboutProc				PROTO :HWND, :UINT, :WPARAM, :LPARAM
DownloadProc			PROTO :HWND
GetWebFileName			PROTO :LPSTR
EnableControl			PROTO :HWND, :DWORD, :DWORD
BrowseForFolderEx		PROTO :DWORD, :DWORD, :DWORD, :DWORD
AddReleaseProc			PROTO :DWORD
QueryInterfaceProc		PROTO :DWORD, :DWORD, :DWORD
OnObjectAvailableProc	PROTO :DWORD, :DWORD, :DWORD
OnDataAvailableProc		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
OnStopBindingProc		PROTO :DWORD, :DWORD, :DWORD
GetBindInfoProc			PROTO :DWORD, :DWORD, :DWORD
OnLowResourceProc		PROTO :DWORD, :DWORD
GetPriorityProc			PROTO :DWORD, :DWORD
OnStartBindingProc		PROTO :DWORD, :DWORD, :DWORD
OnProgressProc			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

; This struct is the key to implementing the callback class. Thanks to ToutEnMasm and Bitrider for this.
IBINDSTATUSCALLBACK		STRUCT
	QueryInterface      DWORD QueryInterfaceProc
	AddRef              DWORD AddReleaseProc
	Release             DWORD AddReleaseProc
	OnStartBinding      DWORD OnStartBindingProc
	GetPriority         DWORD GetPriorityProc
	OnLowResource       DWORD OnLowResourceProc
	OnProgress          DWORD OnProgressProc
	OnStopBinding       DWORD OnStopBindingProc
	GetBindInfo         DWORD GetBindInfoProc
	OnDataAvailable     DWORD OnDataAvailableProc
	OnObjectAvailable   DWORD OnObjectAvailableProc
IBINDSTATUSCALLBACK		ENDS

.CONST
include dialog.inc
.DATA
szStringBuff			CHAR 120 dup(0)
szPath					CHAR MAX_PATH dup(0)

.DATA?
hProgress				DWORD ?
hTitle					DWORD ?
hInstance				HINSTANCE ?
dwDownloadInProgress	DWORD ?
hThread					DWORD ?
lpIDList				DWORD ?
dwInitDone				DWORD ?

.DATA
sIBindStatusCallback	IBINDSTATUSCALLBACK <>
pIBindStatusCallback	DWORD sIBindStatusCallback
icex					INITCOMMONCONTROLSEX <>
sBrowseInfo				BROWSEINFO <>
.CODE
; --> Thanks to Windows 2000, i was unable to use this function as it crashed. I could not figure out why, so i have implemented it in the DialogProc.
; This function is similar to the usual BrowseForFolder from the masm lib, but includes some newer ulFlags that require ole32.dll.
; BrowseForFolderEx PROC hParent:DWORD, lpBuffer:DWORD, lpTitle:DWORD, lpString:DWORD
    ; LOCAL lpIDList:DWORD
    ; LOCAL sBrowseInfo:BROWSEINFO
    ; LOCAL dwInitDone:DWORD
	;LOCAL VerInfo:OSVERSIONINFO
    ; mov eax, hParent
    ; mov sBrowseInfo.hwndOwner, eax
    ; mov sBrowseInfo.pidlRoot, 0
    ; mov sBrowseInfo.pszDisplayName, 0
    ; mov eax, lpString
    ; mov sBrowseInfo.lpszTitle, eax
    ; mov eax, lpTitle
    ; mov sBrowseInfo.lParam, eax
    ; mov sBrowseInfo.iImage, 0
	; mov VerInfo.dwOSVersionInfoSize, sizeof OSVERSIONINFO
	; invoke GetVersionEx, addr VerInfo
	; .IF VerInfo.dwMajorVersion >= 5 && VerInfo.dwMinorVersion >= 1 ; BIF_USENEWUI is available only on XP.
		; mov sBrowseInfo.ulFlags, BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN or BIF_USENEWUI or BIF_RETURNONLYFSDIRS
		; invoke OleInitialize, 0
	; .ELSE
		; mov sBrowseInfo.ulFlags, BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN or BIF_RETURNONLYFSDIRS
    ; .ENDIF
    ; invoke SHBrowseForFolder, addr sBrowseInfo
    ; mov lpIDList, eax
    ; .IF lpIDList == 0
	    ; mov eax, 0
	    ; push eax
	    ; jmp @F
    ; .ELSE
        ; invoke SHGetPathFromIDList,lpIDList,lpBuffer
		; mov eax, 1
        ; push eax
        ; jmp @F
    ; .ENDIF
    ; @@:
    ; invoke CoTaskMemFree,lpIDList
    ; pop eax
    ; ret
; BrowseForFolderEx endp

EnableControl PROC hWnd:HWND, nIDDlgItem:DWORD, bEnable:DWORD
	invoke GetDlgItem, hWnd, nIDDlgItem
	invoke EnableWindow, eax, bEnable
	ret
EnableControl ENDP

; Thanks to White Scorpion for most of this one.
GetWebFileName PROC lpszFilename:LPSTR
	invoke lstrlen, lpszFilename
	mov ecx, eax
	mov eax, lpszFilename
	add eax, ecx
	next:
	cmp byte ptr [eax],2Fh
	jz contin
	dec eax
	jmp next
	contin:
	inc eax
	ret
GetWebFileName ENDP

; The dummy procs for the callback.
AddReleaseProc PROC lpThis:DWORD
	xor eax, eax
	ret
AddReleaseProc ENDP

QueryInterfaceProc PROC lpThis:DWORD, riid:DWORD, ppv:DWORD
	mov eax, E_NOINTERFACE
	ret
QueryInterfaceProc ENDP

OnObjectAvailableProc PROC lpThis:DWORD, riid:DWORD, punk:DWORD
	mov eax, E_NOTIMPL
	ret
OnObjectAvailableProc ENDP

OnDataAvailableProc PROC lpThis:DWORD, grfBSCF:DWORD, dwSize:DWORD,pfmtetc:DWORD,pstgmed:DWORD
	mov eax, E_NOTIMPL
	ret
OnDataAvailableProc ENDP

OnStopBindingProc PROC lpThis:DWORD, hrResult:DWORD, szError:DWORD
	mov eax, E_NOTIMPL
	ret
OnStopBindingProc ENDP

GetBindInfoProc PROC lpThis:DWORD, pgrfBINDF:DWORD, pbindinfo:DWORD
	mov eax, E_NOTIMPL
	ret
GetBindInfoProc ENDP

OnLowResourceProc PROC lpThis:DWORD, dwReserved:DWORD
	mov eax, E_NOTIMPL
	ret
OnLowResourceProc ENDP

GetPriorityProc PROC lpThis:DWORD, pnPriority:DWORD
	mov eax, E_NOTIMPL
	ret
GetPriorityProc ENDP

OnStartBindingProc PROC lpThis:DWORD, grfBSCOption:DWORD, pbinding:DWORD
	mov eax, E_NOTIMPL
	ret
OnStartBindingProc ENDP

; Here is he important one...
OnProgressProc PROC lpThis:DWORD, ulProgress:DWORD,ulProgressMax:DWORD,ulStatusCode:DWORD,szStatusText:DWORD
	invoke wsprintf, addr szStringBuff, chr$("Completed %i of %i bytes..."), ulProgress, ulProgressMax
	invoke SendMessage, hTitle, WM_SETTEXT, 0, offset szStringBuff
	invoke SendMessage, hProgress, PBM_SETRANGE32, 0, ulProgressMax
	invoke SendMessage, hProgress, PBM_SETPOS, ulProgress, 0
	mov eax, S_OK
	ret
OnProgressProc ENDP

DownloadProc PROC hWnd:HWND
	mov dwDownloadInProgress, 1
	invoke GetDlgItemText, hWnd, IDC_DESTINATION, addr szPath, MAX_PATH
	invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_GETCURSEL, 0, 0
	; CB_GETITEMDATA will return the ID if the string we need to load.
	invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_GETITEMDATA, eax, 0
	invoke LoadString, hInstance, eax, addr szStringBuff, 512
	invoke EnableControl, hWnd, IDC_CANCEL, TRUE
	invoke EnableControl, hWnd, IDC_DOWNLOAD, FALSE
	invoke SetDlgItemText, hWnd, IDC_TITLE, chr$("Commencing Download...Please Wait.")
	invoke GetWebFileName, addr szStringBuff
	invoke wsprintf, addr szPath, chr$("%s\%s"), addr szPath, eax ; Fortunately, Windows will handle multiple backslahes in a path.
	invoke URLDownloadToFile, NULL, addr szStringBuff, addr szPath, NULL, addr pIBindStatusCallback
	; Error checking is not working as it should.
	.IF eax != S_OK
		invoke SetDlgItemText, hWnd, IDC_TITLE, chr$("Download Failed.")
	.ENDIF
	invoke EnableControl, hWnd, IDC_CANCEL, FALSE
	invoke EnableControl, hWnd, IDC_DOWNLOAD, TRUE
	mov dwDownloadInProgress, 0
	invoke SetDlgItemText, hWnd, IDC_TITLE, chr$("Download Complete.")
	invoke ExitThread, NULL
	ret
DownloadProc ENDP

AboutProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg == WM_INITDIALOG
	    invoke SetDlgItemText, hWnd, IDC_ABOUTTEXT, chr$("To Paul, friend, mentor and helper of so many. A legacy that will not be forgotten.", 13, 10, 13, 10, "Much thanks to Bitrider and TouEnMasm for implementing the IBindStatusCallback for me!!!", 13, 10, 13, 10, "Ehtyar.")
	.ELSEIF uMsg == WM_COMMAND
	    .IF wParam == IDC_CLOSE
	        invoke SendMessage, hWnd, WM_CLOSE, 0, 0
		.ELSEIF wParam == IDC_PBRENNICK
			invoke ShellExecute, NULL, chr$("open"), chr$("http://www.pbrennick.com/"), NULL, NULL, SW_SHOWNORMAL
		.ELSEIF wParam == IDC_GENESYS
			invoke ShellExecute, NULL, chr$("open"), chr$("http://x86assembly.codegurus.org/"), NULL, NULL, SW_SHOWNORMAL
	    .ENDIF
	.ELSEIF uMsg == WM_CLOSE
		invoke EndDialog, hWnd, 0
	.ENDIF
	xor eax, eax
	ret
AboutProc ENDP

DialogProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg == WM_INITDIALOG
		invoke LoadIcon,hInstance,IDI_APPLICATION
		invoke SendMessage,hWnd,WM_SETICON,1,eax
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("Entire Package (GeneSys.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_GENESYS_PACKAGE
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("GeneSys DLL (GeneSysDll.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_GENESYS_DLL
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("GeneSys LIB (GeneSysLib.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_GENESYS_LIB
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("ASM LIB (asmLib.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_ASM_LIB
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("ASM DLL (asmDll.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_ASM_DLL
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("Iczelion's Tutorials (Iczelion.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_TUTS_ZIP
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("Iczelion's Tutorials (tutorials.exe)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_TUTS_EXE
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("GeneSys Examples (Examples.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_MISC_EXAMPLES
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("C & ASM Mixed Examples (C&asm.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_MISC_CASM
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_ADDSTRING, 0, chr$("SendMail Utility (SendMail.zip)")
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETITEMDATA, eax, IDS_MISC_SENDMAIL
		invoke SendDlgItemMessage, hWnd, IDC_PACKAGE, CB_SETCURSEL, 0, 0
		invoke GetDlgItem, hWnd, IDC_PROGRESS
		mov hProgress, eax
		invoke GetDlgItem, hWnd, IDC_TITLE
		mov hTitle, eax
	.ELSEIF uMsg == WM_COMMAND
		.IF wParam == IDC_EXIT
			.IF dwDownloadInProgress == 1
				invoke MessageBox, hWnd, chr$("This will leave a partially downloaded file on your system.", 13, 10, "Are you sure?"), chr$("Terminate Thread"), MB_YESNO or MB_ICONQUESTION
				.IF eax == IDYES
					invoke TerminateThread, hThread, NULL
					invoke SendMessage, hWnd, WM_CLOSE, NULL, NULL
					ret
				.ELSE
					ret
				.ENDIF
			.ENDIF
			invoke SendMessage, hWnd, WM_CLOSE, NULL, NULL
		.ELSEIF wParam == IDC_DOWNLOAD
			; Use a thread for the download itself so that it may be canceled by the user.
			invoke CreateThread, NULL, NULL, addr DownloadProc, hWnd, NULL, NULL
			mov hThread, eax
		.ELSEIF wParam == IDC_ABOUT
	        invoke DialogBoxParam, hInstance, IDD_ABOUT, hWnd, offset AboutProc, 0
		.ELSEIF wParam == IDC_BROWSE
			mov eax, hWnd
		    mov sBrowseInfo.hwndOwner, eax
		    mov sBrowseInfo.pidlRoot, 0
		    mov sBrowseInfo.pszDisplayName, 0
		    mov sBrowseInfo.lpszTitle, chr$("Browse For Folder")
		    mov sBrowseInfo.iImage, 0
			mov sBrowseInfo.ulFlags, BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN or BIF_RETURNONLYFSDIRS
		    invoke SHBrowseForFolder, addr sBrowseInfo
			push eax
		    .IF eax != 0
		        invoke SHGetPathFromIDList, eax, addr szPath
				invoke SetDlgItemText, hWnd, IDC_DESTINATION, addr szPath
		    .ENDIF
			pop eax
		    invoke CoTaskMemFree, eax
			; mov szPath[0], 0 ; Lame trick to prevent BrowseForFolder returning NULL in the path buffer, but TRUE in eax.
            ; invoke BrowseForFolderEx, hWnd, addr szPath, chr$("Browse For Folder"), chr$("Please select the destination folder for the downloaded file.")
            ; .IF eax != 0 && szPath[0] != 0
                ; invoke SetDlgItemText, hWnd, IDC_DESTINATION, addr szPath
            ; .ENDIF
		.ELSEIF wParam == IDC_CANCEL
			invoke MessageBox, hWnd, chr$("This will leave a partially downloaded file on your system.", 13, 10, "Are you sure?"), chr$("Terminate Thread"), MB_YESNO or MB_ICONQUESTION
			.IF eax == IDYES
				invoke TerminateThread, hThread, NULL
				invoke EnableControl, hWnd, IDC_CANCEL, FALSE
				invoke EnableControl, hWnd, IDC_DOWNLOAD, TRUE
				invoke SetDlgItemText, hWnd, IDC_TITLE, chr$("Download Terminated.")
				mov dwDownloadInProgress, 0
			.ENDIF
		.ENDIF
	.ELSEIF uMsg == WM_CLOSE
		invoke EndDialog, hWnd, 0
	.ENDIF
	xor eax, eax
	ret
DialogProc ENDP

start:
invoke GetModuleHandle, NULL
mov hInstance, eax
invoke DialogBoxParam, eax, IDD_DIALOG, NULL, addr DialogProc, 0
invoke ExitProcess, 0
mov icex.dwSize, sizeof INITCOMMONCONTROLSEX
mov icex.dwICC, ICC_BAR_CLASSES
invoke InitCommonControlsEx, addr icex
END start